/*
 * $Id: pointerprefs.c,v 1.1.1.1 2005/03/15 16:01:01 laire Exp $
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"
#include <proto/iffparse.h>
#include <aros/asmcall.h>

#define DEBUG 0
#include <aros/debug.h>

struct IPointerColorPrefs
{
	UWORD Num;
	UWORD Red;
	UWORD Green;
	UWORD Blue;
	UWORD NotZero;
	UWORD Pad[3];
};

struct IPointerPrefs
{
	struct BitMap *BitMap;
	WORD  XOffset;
	WORD  YOffset;
	UWORD WordWidth;
	UWORD Size;
	UWORD YSize;
	UWORD Which;
	ULONG Zero;
};

AROS_UFH1(LONG, PointerPrefs_Handler,
		  AROS_UFHA(struct IFFHandle *, iff, A2))
{
	AROS_LIBFUNC_INIT

	struct PointerPrefs iprefs;

	D(bug("IPrefs: PointerPrefs\n"));

	if (ReadChunkBytes(iff, &iprefs, sizeof(iprefs)) == sizeof(iprefs))
	{
		int numEntries = (1 << iprefs.pp_Depth) - 1;
		struct IPointerPrefs prefs;
		struct BitMap *bitmap;
		int k;

		for (k = 0; k < numEntries; ++k)
		{
			struct RGBTable color;
			struct IPointerColorPrefs cprefs;

			ReadChunkBytes(iff, &color, sizeof(color));

			cprefs.Num   = k + 8;
			cprefs.Red   = color.t_Red   * 0x101;
			cprefs.Green = color.t_Green * 0x101;
			cprefs.Blue  = color.t_Blue  * 0x101;
			cprefs.NotZero = 0xffff;
			SetIPrefs(&cprefs, sizeof(cprefs), IP_PTRCOLOR);
		}

		if ((bitmap = AllocBitMap( iprefs.pp_Width, iprefs.pp_Height, iprefs.pp_Depth, BMF_CLEAR, NULL)))
		{
			ULONG bpr = ((iprefs.pp_Width + 15) >> 4) << 1;
			int j, k;

			for (k = 0; k < iprefs.pp_Depth; ++k)
			{
				for (j = 0; j < iprefs.pp_Height; ++j)
				{
					ReadChunkBytes(iff, bitmap->Planes[k] + j * bitmap->BytesPerRow, bpr);
				}
			}

			prefs.BitMap = bitmap;
			prefs.XOffset = iprefs.pp_X;
			prefs.YOffset = iprefs.pp_Y;
			prefs.WordWidth = bpr >> 1;
			prefs.Size = iprefs.pp_Size;
			prefs.YSize = iprefs.pp_YSize;
			prefs.Which = iprefs.pp_Which;
			prefs.Zero = 0;
			SetIPrefs(&prefs, sizeof(prefs), IP_POINTER);

			FreeBitMap(bitmap);
		}
	}

	return 0;

	AROS_LIBFUNC_EXIT
}
