/*
 * $Id: printergfxprefs.c,v 1.1.1.1 2005/03/15 16:01:01 laire Exp $
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"
#include <proto/iffparse.h>
#include <aros/asmcall.h>

#define DEBUG 0
#include <aros/debug.h>


AROS_UFH1(LONG, PrinterGfxPrefs_Handler,
		  AROS_UFHA(struct IFFHandle *, iff, A2))
{
	AROS_LIBFUNC_INIT

	struct Preferences     prefs;
	struct PrinterGfxPrefs iprefs;
	LONG   retvalue = FALSE;

	D(bug("IPrefs: PrinterGfxPrefs\n"));

	if (ReadChunkBytes(iff, &iprefs, sizeof(iprefs)) == sizeof(iprefs))
	{
		GetPrefs(&prefs,sizeof(struct Preferences));

		prefs.PrintImage     =  iprefs.pg_Image;
		prefs.PrintAspect    =  iprefs.pg_Aspect;
		prefs.PrintShade     =  iprefs.pg_Shade;
		prefs.PrintThreshold =  iprefs.pg_Threshold;

		prefs.PrintFlags     &= ~(GREY_SCALE2);
		prefs.PrintFlags     &= ~(CORRECT_RED|CORRECT_GREEN|CORRECT_BLUE);
		prefs.PrintFlags     |= iprefs.pg_ColorCorrect;
		prefs.PrintDensity   =  iprefs.pg_PrintDensity;
		prefs.PrintMaxWidth  =  iprefs.pg_PrintMaxWidth;
		prefs.PrintMaxHeight =  iprefs.pg_PrintMaxHeight;
		prefs.PrintXOffset   =  iprefs.pg_PrintXOffset;

		if (iprefs.pg_Shade == PS_GREY_SCALE2)
		{
		    prefs.PrintShade =  SHADE_GREYSCALE;
		    prefs.PrintFlags |= GREY_SCALE2;
		}

		prefs.PrintFlags &= ~(BOUNDED_DIMENSIONS|ABSOLUTE_DIMENSIONS|PIXEL_DIMENSIONS|MULTIPLY_DIMENSIONS);

		if (iprefs.pg_Dimensions != IGNORE_DIMENSIONS)
		{
		    prefs.PrintFlags |= (0x10 << iprefs.pg_Dimensions);
		}

		prefs.PrintFlags &= ~(FLOYD_DITHERING|HALFTONE_DITHERING);

		if (iprefs.pg_Dithering != PD_ORDERED)
		{
		    prefs.PrintFlags |= (0x100 << iprefs.pg_Dithering);
		}

		prefs.PrintFlags &= ~(ANTI_ALIAS|INTEGER_SCALING|CENTER_IMAGE);

		if (iprefs.pg_GraphicFlags & PGFF_CENTER_IMAGE)
		{
		    prefs.PrintFlags |= CENTER_IMAGE;
		}

		if (iprefs.pg_GraphicFlags & PGFF_INTEGER_SCALING)
		{
		    prefs.PrintFlags |= INTEGER_SCALING;
		}

		if (iprefs.pg_GraphicFlags & PGFB_ANTI_ALIAS)
		{
		    prefs.PrintFlags |= ANTI_ALIAS;
		}


		SetPrefs(&prefs,sizeof(struct Preferences),FALSE);

		retvalue = TRUE;
	}

	return retvalue;

	AROS_LIBFUNC_EXIT
}
